
#include <windows.h>
#include "pluginW3.hpp"
#include <TCHAR.H>
#include <crtdbg.h>

struct PluginStartupInfo psi;
struct FarStandardFunctions FSFW;

BOOL APIENTRY DllMain( HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved )
{
	switch (ul_reason_for_call) {
		case DLL_PROCESS_ATTACH:
			break;
	}
	return TRUE;
}

static GUID guidPlugin = { /* 43b89921-35c8-447f-aeba-1b76067d4e0e */
    0x43b89921,
    0x35c8,
    0x447f,
    {0xae, 0xba, 0x1b, 0x76, 0x06, 0x7d, 0x4e, 0x0e}
};

void WINAPI GetGlobalInfoW(GlobalInfo *Info)
{
	Info->StructSize = sizeof(GlobalInfo);
	Info->MinFarVersion = FARMANAGERVERSION;
	Info->Version = MAKEFARVERSION(1,0,0,0,VS_RC);
	Info->Guid = guidPlugin;
	Info->Title = L"Far3 Key test";
	Info->Description = L"Far3 Key test";
	Info->Author = L"Maximus5";
}

void WINAPI GetPluginInfoW(struct PluginInfo *pi)
{
	//static TCHAR szMenu[MAX_PATH];
	//lstrcpy(szMenu, _T("Far3 Key Test"));
	//static TCHAR *pszMenu[1];
	//pszMenu[0] = szMenu;

	memset(pi, 0, sizeof(struct PluginInfo));
	pi->StructSize = sizeof(struct PluginInfo);

	static TCHAR szMenu[MAX_PATH];
	lstrcpy(szMenu, L"Far3 Key Test");
    static TCHAR *pszMenu[1];
    pszMenu[0] = szMenu;
    
    static GUID guid_PluginMenu = { /* afadaa7b-6f93-4236-8581-9b3b7e2f46c0 */
	    0xafadaa7b,
	    0x6f93,
	    0x4236,
	    {0x85, 0x81, 0x9b, 0x3b, 0x7e, 0x2f, 0x46, 0xc0}
	};
	
	pi->PluginMenu.Guids = &guid_PluginMenu;
	pi->PluginMenu.Strings = pszMenu;
	pi->PluginMenu.Count = 1;
}

void WINAPI SetStartupInfoW(const PluginStartupInfo *aInfo)
{
	::psi = *aInfo;
	::FSFW = *aInfo->FSF;
	::psi.FSF = &::FSFW;
}

HANDLE WINAPI OpenW(const struct OpenInfo *Info)
{
	wchar_t szInfo[1024]; lstrcpy(szInfo, L"FarInputRecordToName failed\n");
	struct {
		LPCWSTR pszKey;
		wchar_t szDbg[128];
		int nNull;
		bool Cmp;
		INPUT_RECORD r;
	} Keys[] = {
		{L"MsWheelUp"},
		{L"MsLClick"},
		{L"MsRClick"},
		{L"MsM1Click"},
		{L"CtrlMsWheelUp"},
		{L"CtrlMsLClick"},
		{L"CtrlMsRClick"},
		{L"CtrlMsM1Click"},
		{L"NumEnter"},
		{L"CtrlNumEnter"},
		{L"AltF"}, 
		{L"AltBS"},
		{L"RAltF"},
		{L"RAltBS"},
		{L"CtrlR"},
		{L"RCtrlR"},
		{L"AltShiftBS"},
		{L"CtrlAltBS"},
		{L"CtrlBreak"},
		{L"Shift-"},
		{L"Shift_"},
		{L"RAltShift-"},
	};
	int lFail = -1;
	BOOL b1; size_t nDbgSize;
	for (UINT i = 0; i < ARRAYSIZE(Keys); i++)
	{
		b1 = FSFW.FarNameToInputRecord(Keys[i].pszKey, &Keys[i].r);
		nDbgSize = FSFW.FarInputRecordToName(&Keys[i].r, Keys[i].szDbg, ARRAYSIZE(Keys[i].szDbg));
		Keys[i].Cmp = lstrcmpi(Keys[i].pszKey, Keys[i].szDbg)==0;
		if (!Keys[i].Cmp)
		{
			wsprintf(szInfo+lstrlen(szInfo), L"`%s` -> `%s`\n", Keys[i].pszKey, Keys[i].szDbg);
			if (lFail==-1)
				lFail = i;
		}
	}
	if (lFail != -1)
	{
		_ASSERTE(lFail == -1);
		//MessageBox(NULL, szInfo, L"FarInputRecordToName failed", MB_SYSTEMMODAL);
		psi.Message(&guidPlugin, &guidPlugin, FMSG_ALLINONE|FMSG_MB_OK|FMSG_WARNING,
			NULL, (const wchar_t * const *)szInfo, 0, 0);
	}
    
	return INVALID_HANDLE_VALUE;
}
